/**
 *  traffic
 *  Author: Patrick Taillandier
 *  Description: step 1
 */

model traffic

global {
	file shapefile_buildings <- file("../includes/buildings.shp");
	file shapefile_roads <- file("../includes/roads.shp");
	geometry shape <- envelope(shapefile_roads);
	
	init {
		create building from: shapefile_buildings;
		create road from: shapefile_roads;
	}
}

species building {
	aspect geom {
		draw shape color: #gray;
	}
}

species road {
	aspect geom {
		draw shape color: #black;
	}
}
experiment traffic type: gui {
	output {
		display map {
			species building aspect: geom refresh: false;
			species road aspect: geom ;
		}
	}
}
