/**
 *  traffic
 *  Author: Patrick Taillandier
 *  Description: step 2
 */

model traffic

global {
	file shapefile_buildings <- file("../includes/buildings.shp");
	file shapefile_roads <- file("../includes/roads.shp");
	geometry shape <- envelope(shapefile_roads);
	
	init {
		create building from: shapefile_buildings;
		create road from: shapefile_roads;
		create inhabitant number: 1000{
			location <- any_location_in(one_of(building));
      	}
	}
	
}

species inhabitant skills: [moving]{
	point target <- nil;
	float proba_leave <- 0.05; 
	float speed <- 5 #km/#h;
	rgb color <- rnd_color(255);
	
	aspect circle {
		draw circle(5) color: color;
	}
}

species building {
	aspect geom {
		draw shape color: #gray;
	}
}

species road {
	aspect geom {
		draw shape color: #black;
	}
}
experiment traffic type: gui {
	output {
		display map type: opengl{
			species building aspect: geom refresh: false;
			species road aspect: geom;
			species inhabitant aspect: circle;
		}
	}
}
